## GstVideoAggregator

GstVideoAggregator — Base class for video aggregators

## Types and Values

struct | GstVideoAggregator
struct | GstVideoAggregatorClass

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GstObject
                ╰── GstElement
                    ╰── GstAggregator
                        ╰── GstVideoAggregator

## Includes

    #include <gst/video/video.h>

## Description

VideoAggregator can accept AYUV, ARGB and BGRA video streams. For each of the requested sink pads it will compare the incoming geometry and framerate to define the output parameters. Indeed output video frames will have the geometry of the biggest incoming video stream and the framerate of the fastest incoming one.

VideoAggregator will do colorspace conversion.

Zorder for each input stream can be configured on the GstVideoAggregatorPad.

## Functions

## Types and Values

### struct GstVideoAggregator

    struct GstVideoAggregator {
      /* Output caps */
      GstVideoInfo               info;
    };

#### Members

GstVideoInfo `info`; | The GstVideoInfo representing the currently set srcpad caps. |

### struct GstVideoAggregatorClass

    struct GstVideoAggregatorClass {
      GstCaps *          (*update_caps)               (GstVideoAggregator *  videoaggregator,
                                                       GstCaps            *  caps);
      GstFlowReturn      (*aggregate_frames)          (GstVideoAggregator *  videoaggregator,
                                                       GstBuffer          *  outbuffer);
      GstFlowReturn      (*create_output_buffer)      (GstVideoAggregator *  videoaggregator,
                                                       GstBuffer          ** outbuffer);
      void               (*find_best_format)          (GstVideoAggregator *  vagg,
                                                       GstCaps            *  downstream_caps,
                                                       GstVideoInfo       *  best_info,
                                                       gboolean           *  at_least_one_alpha);
    };

#### Members

`update_caps` () | Optional. Lets subclasses update the GstCaps representing the src pad caps before usage. Return `NULL` to indicate failure. |

`aggregate_frames` ()

Lets subclasses aggregate frames that are ready. Subclasses should iterate the GstElement.sinkpads and use the already mapped GstVideoFrame from `gst_video_aggregator_pad_get_prepared_frame()` or directly use the GstBuffer from `gst_video_aggregator_pad_get_current_buffer()` if it needs to map the buffer in a special way. The result of the aggregation should land in `outbuffer` .

`create_output_buffer` () | Optional. Lets subclasses provide a GstBuffer to be used as `outbuffer` of the aggregate_frames vmethod. |
`find_best_format` () | Optional. Lets subclasses decide of the best common format to use. |